- README

- Top Level Namespace
- Adler32
- ArgumentError
- Array
- Atomic
- Base64
  - Error
- Benchmark
  - BM
    - Job
    - Tms
  - IPS
    - Entry
    - Job
- BigFloat
- BigInt
- BigRational
- BitArray
- Bool
- Box
- Bytes
- Channel
  - Buffered
  - ClosedError
  - ReceiveAction
  - SelectAction
  - SendAction
  - Unbuffered
- Char
  - Reader
- Class
- Colorize
  - Object
  - ObjectExtensions
- Comparable
- Complex
- Concurrent
  - CanceledError
- CRC32
- Crypto
  - Bcrypt
    - Error
    - Password
  - Blowfish
  - Subtle
- CSV
  - Builder
    - Row
  - Error
  - Lexer
  - MalformedCSVError
  - Parser
  - Row
  - Token
    - Kind
- Debug
  - DWARF
    - Abbrev
      - Attribute
    - AT
    - FORM
    - Info
      - Value
    - LineNumbers
      - Register
      - Row
      - Sequence
    - LNE
    - LNS
    - Strings
    - TAG
  - ELF
    - Endianness
    - Error
    - Ident
    - Klass
    - Machine
    - OSABI
    - SectionHeader
      - Flags
      - Type
    - Type
- Deque
- Digest
  - Base
  - MD5
  - SHA1
- Dir
- DivisionByZero
- DL
- ECR
- Enum
- Enumerable
  - EmptyError
- ENV
- Errno
- Exception
- Fiber
- File
  - Stat
- FileUtils
- Flate
  - Error
  - Reader
  - Strategy
  - Writer
- Float
  - Primitive
- Float32
- Float64
- GC
  - Stats
- Gzip
  - Error
  - Header
  - Reader
  - Writer
- Hash
- HTML
- HTTP
  - Client
    - BodyType
    - Response
  - CompressHandler
  - ComputedContentTypeHeader
  - Cookie
  - Cookies
  - ErrorHandler
  - FormData
    - Builder
    - Error
    - FileMetadata
    - Parser
    - Part
  - Handler
    - Proc
  - Headers
  - LogHandler
  - Multipart
    - Builder
    - Error
    - Parser
  - Params
    - Builder
  - Request
  - Server
    - Context
    - RequestProcessor
    - Response
  - StaticFileHandler
    - DirectoryListing
  - WebSocket
  - WebSocketHandler
- Indexable
- IndexError
- INI
- Int
  - Primitive
  - Signed
  - Unsigned
- Int16
- Int32
- Int64
- Int8
- InvalidByteSequenceError
- IO
  - Buffered
  - ByteFormat
    - BigEndian
    - LittleEndian
    - NetworkEndian
    - SystemEndian
  - Delimited
  - EncodingOptions
  - EOFError
  - Error
  - FileDescriptor
  - Hexdump
  - Memory
  - MultiWriter
  - Seek
  - Sized
  - Timeout
- IPSocket
- Iterable
- Iterator
  - IteratorWrapper
  - Stop
- JSON
  - Any
  - Builder
    - ArrayState
    - DocumentEndState
    - DocumentStartState
    - ObjectState
    - StartState
    - State
  - Error
  - Lexer
  - ParseException
  - Parser
  - PullParser
  - Token
  - Type
- KeyError
- Levenshtein
  - Finder
- LLVM
  - ABI
    - AArch64
    - ArgKind
    - ArgType
    - ARM
    - FunctionType
    - X86
    - X86_64
      - RegClass
  - AtomicOrdering
  - AtomicRMWBinOp
  - Attribute
  - AttributeIndex
  - BasicBlock
  - BasicBlockCollection
  - Builder
  - CallConvention
  - CodeGenFileType
  - CodeGenOptLevel
  - CodeModel
  - Context
  - DIBuilder
  - DIFlags
  - DwarfTag
  - DwarfTypeEncoding
  - Function
  - FunctionCollection
  - FunctionPassManager
    - Runner
  - GenericValue
  - GlobalCollection
  - InstructionCollection
  - IntPredicate
  - JITCompiler
  - Linkage
  - MemoryBuffer
  - Module
  - ModuleFlag
  - ModulePassManager
  - ParameterCollection
  - PassManagerBuilder
  - PassRegistry
  - PhiTable
  - RealPredicate
  - RelocMode
  - Target
  - TargetData
  - TargetMachine
  - Type
    - Kind
  - Value
    - Kind
  - ValueMethods
  - VerifierFailureAction
- Logger
  - Formatter
  - Severity
- Markdown
  - HTMLRenderer
  - Parser
    - PrefixHeader
    - UnorderedList
  - Renderer
- Math
- Mutex
- NamedTuple
- Nil
- Number
  - Primitive
- OAuth
  - AccessToken
  - Consumer
  - Error
  - RequestToken
- OAuth2
  - AccessToken
    - Bearer
    - Mac
  - Client
  - Error
  - Session
- Object
- OpenSSL
  - Digest
    - Error
    - UnsupportedError
  - DigestBase
  - Error
  - HMAC
  - MD5
  - SHA1
  - SSL
    - Context
      - Client
      - Server
    - Error
    - ErrorType
    - Modes
    - Options
    - Socket
      - Client
      - Server
    - VerifyMode
    - X509VerifyFlags
- OptionParser
  - Exception
  - InvalidOption
  - MissingOption
- PartialComparable
- Pointer
  - Appender
- PrettyPrint
- Proc
- Process
  - Env
  - Status
  - Stdio
  - Tms
- Random
  - MT19937
- Range
- Readline
  - CompletionProc
  - KeyBindingProc
- Reference
- Reflect
- Regex
  - MatchData
  - Options
- SecureRandom
- Set
- Signal
- Slice
- Socket
  - Address
  - Addrinfo
  - Error
  - Family
  - IPAddress
  - Protocol
  - Server
  - Type
  - UNIXAddress
- Spec
  - Expectations
  - Methods
  - ObjectExtensions
- StaticArray
- String
  - Builder
  - RawConverter
- StringPool
- StringScanner
- Struct
- Symbol
- System
- TCPServer
- TCPSocket
- Tempfile
- Termios
  - AttributeSelection
  - BaudRate
  - ControlMode
  - InputMode
  - LineControl
  - LocalMode
  - OutputMode
- Time
  - DayOfWeek
  - EpochConverter
  - EpochMillisConverter
  - Format
    - Error
  - Kind
  - MonthSpan
  - Span
- Tuple
- TypeCastError
- UDPSocket
- UInt16
- UInt32
- UInt64
- UInt8
- Unicode
  - CaseOptions
- Union
- UNIXServer
- UNIXSocket
- URI
  - Error
- Value
- WeakRef
- XML
  - Attributes
  - AttributeType
  - Builder
  - Error
  - HTMLParserOptions
  - Namespace
  - Node
  - NodeSet
  - ParserOptions
  - Reader
  - SaveOptions
  - Type
  - XPathContext
- YAML
  - Any
  - Builder
  - Error
  - EventKind
  - ParseException
  - Parser
  - PullParser
  - Type
- Zip
  - CompressionMethod
  - Error
  - File
    - Entry
  - FileInfo
  - Reader
    - Entry
  - Writer
    - Entry
- Zlib
  - Error
  - Reader
  - Writer

# enum LLVM::Attribute

## Defined in:

## Enum Members

None = `0_u64`
Alignment = `1_u64`
AllocSize = `2_u64`
AlwaysInline = `4_u64`
ArgMemOnly = `8_u64`
Builtin = `16_u64`
ByVal = `32_u64`
Cold = `64_u64`
Convergent = `128_u64`
Dereferenceable = `256_u64`
DereferenceableOrNull = `512_u64`
InAlloca = `1024_u64`
InReg = `2048_u64`
InaccessibleMemOnly = `4096_u64`
InaccessibleMemOrArgMemOnly = `8192_u64`
InlineHint = `16384_u64`
JumpTable = `32768_u64`
MinSize = `65536_u64`
Naked = `131072_u64`
Nest = `262144_u64`
NoAlias = `524288_u64`
NoBuiltin = `1048576_u64`
NoCapture = `2097152_u64`
NoDuplicate = `4194304_u64`
NoImplicitFloat = `8388608_u64`
NoInline = `16777216_u64`
NoRecurse = `33554432_u64`
NoRedZone = `67108864_u64`
NoReturn = `134217728_u64`
NoUnwind = `268435456_u64`
NonLazyBind = `536870912_u64`
NonNull = `1073741824_u64`
OptimizeForSize = `2147483648_u64`
OptimizeNone = `4294967296_u64`
ReadNone = `8589934592_u64`
ReadOnly = `17179869184_u64`
Returned = `34359738368_u64`
ReturnsTwice = `68719476736_u64`
SExt = `137438953472_u64`
SafeStack = `274877906944_u64`
SanitizeAddress = `549755813888_u64`
SanitizeMemory = `1099511627776_u64`
SanitizeThread = `2199023255552_u64`
StackAlignment = `4398046511104_u64`
StackProtect = `8796093022208_u64`
StackProtectReq = `17592186044416_u64`
StackProtectStrong = `35184372088832_u64`
StructRet = `70368744177664_u64`
SwiftError = `140737488355328_u64`
SwiftSelf = `281474976710656_u64`
UWTable = `562949953421312_u64`
WriteOnly = `1125899906842624_u64`
ZExt = `2251799813685248_u64`

## Class Method Summary

- .from_kind(kind)
- .kind_for(member)

## Instance Method Summary

- #alignment?
- #alloc_size?
- #always_inline?
- #arg_mem_only?
- #builtin?
- #by_val?
- #cold?
- #convergent?
- #dereferenceable?
- #dereferenceable_or_null?
- #each_kind(&block)
- #in_alloca?
- #in_reg?
- #inaccessible_mem_only?
- #inaccessible_mem_or_arg_mem_only?
- #inline_hint?
- #jump_table?
- #min_size?
- #naked?
- #nest?
- #no_alias?
- #no_builtin?
- #no_capture?
- #no_duplicate?
- #no_implicit_float?
- #no_inline?
- #no_recurse?
- #no_red_zone?
- #no_return?
- #no_unwind?
- #non_lazy_bind?
- #non_null?
- #none?
- #optimize_for_size?
- #optimize_none?
- #read_none?
- #read_only?
- #returned?
- #returns_twice?
- #s_ext?
- #safe_stack?
- #sanitize_address?
- #sanitize_memory?
- #sanitize_thread?
- #stack_alignment?
- #stack_protect?
- #stack_protect_req?
- #stack_protect_strong?
- #struct_ret?
- #swift_error?
- #swift_self?
- #uw_table?
- #write_only?
- #z_ext?

### Instance methods inherited from struct `Enum`

&(other : self) &, +(other : Int) +, -(other : Int) -, <=>(other : self) <=>, ==(other : self) ==, ^(other : self) ^, clone clone, each(&block) each, hash hash, includes?(other : self) includes?, to_f32 : Float32 to_f32, to_f64 : Float64 to_f64, to_i : Int32 to_i, to_i16 : Int16 to_i16, to_i32 : Int32 to_i32, to_i64 : Int64 to_i64, to_i8 : Int8 to_i8, to_json(json : JSON::Builder) to_json, to_s(io : IO) : Nil
to_s : String to_s, to_u16 : UInt16 to_u16, to_u32 : UInt32 to_u32, to_u64 : UInt64 to_u64, to_u8 : UInt8 to_u8, to_yaml(yaml : YAML::Builder) to_yaml, |(other : self) |, ~ ~

### Class methods inherited from struct `Enum`

each(&block) each, from_value(value) : self from_value, from_value?(value) : self? from_value?, names : Array(String) names, new(pull : JSON::PullParser)
new(pull : YAML::PullParser) new, parse(string) : self parse, parse?(string) : self? parse?, values : Array(self) values

### Instance methods inherited from module `Comparable(self)`

<(other : T) <, <=(other : T) <=, <=>(other : T) <=>, ==(other : T) ==, >(other : T) >, >=(other : T) >=

### Instance methods inherited from struct `Value`

==(other) ==, dup dup

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, class class, dup dup, hash hash, inspect(io : IO)
inspect inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&block) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s
to_s(io : IO) to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&block) try

### Class methods inherited from class `Object`

from_json(string_or_io, root : String) : self
from_json(string_or_io) : self from_json, from_yaml(string_or_io) : self from_yaml

## Class Method Detail

def self.from_kind(kind) #
def self.kind_for(member) #

## Instance Method Detail

def alignment? #
def alloc_size? #
def always_inline? #
def arg_mem_only? #
def builtin? #
def by_val? #
def cold? #
def convergent? #
def dereferenceable? #
def dereferenceable_or_null? #
def each_kind(&block) #
def in_alloca? #
def in_reg? #
def inaccessible_mem_only? #
def inaccessible_mem_or_arg_mem_only? #
def inline_hint? #
def jump_table? #
def min_size? #
def naked? #
def nest? #
def no_alias? #
def no_builtin? #
def no_capture? #
def no_duplicate? #
def no_implicit_float? #
def no_inline? #
def no_recurse? #
def no_red_zone? #
def no_return? #
def no_unwind? #
def non_lazy_bind? #
def non_null? #
def none? #
def optimize_for_size? #
def optimize_none? #
def read_none? #
def read_only? #
def returned? #
def returns_twice? #
def s_ext? #
def safe_stack? #
def sanitize_address? #
def sanitize_memory? #
def sanitize_thread? #
def stack_alignment? #
def stack_protect? #
def stack_protect_req? #
def stack_protect_strong? #
def struct_ret? #
def swift_error? #
def swift_self? #
def uw_table? #
def write_only? #
def z_ext? #